#!/usr/bin/python

import fonctions
from math import *
import os

def liste(init,fin,pas):
	list = []
	while init<=fin:
		list.append(init)
		init += pas
	return list
		
def initialisation():
	#Remove stale files
	username = os.environ.get("USER");
	
	if os.path.exists('/tmp/%s-farfadet'%(username)):
		print("Stale file detected... removing it\n");
		os.remove("/tmp/%s-farfadet"%(username));

#a revoir le passage des arguments
def trace(args, phenomene, graph_style, list_comp):
	# args = (E), (R), (L), (C), Time, (r)

	time = args[-1][1]
	
	username = os.environ.get("USER")
		
	coord = open("/tmp/%s-farfadet"%(username),'a')	
	
	if os.path.exists('/tmp/%s-phase'%(username)):
		os.remove("/tmp/%s-phase"%(username))
	
	phase = open("/tmp/%s-phase"%(username), "w")
	#phase.write("set xlabel \"Time (s)\"\n")
	phase.write("set grid\n")
	phase.write("set term png\n")
	phase.write("set output \'/tmp/%s-gnuplot-output.png\'\n"%(username))
	phase.write("set size 0.8,0.8\n")
	
	
	if phenomene == 'GRL_I':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0, time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.GRL_I(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RL_I':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RL_I(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'GRC_Q':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.GRC_Q(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'GRC_Uc':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.GRC_Uc(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'GRC_I':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.GRC_I(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RC_Uc':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RC_Uc(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RC_I':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RC_I(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RC_Q':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RC_Q(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'LC_I':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.LC_I(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'LC_Q':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.LC_Q(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RLC_Q':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RLC_Q(k,args[0][1], args[1][1], args[2][1], args[3][1])[1]))
	elif phenomene == 'LC_Ul':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.LC_Ul(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'LC_Uc':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.LC_Uc(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RL_Ul':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RL_Ul(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'RLC_Uc':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RLC_Uc(k,args[0][1], args[1][1], args[2][1], args[3][1])[1]))
	elif phenomene == 'RLC_Ul':	
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RLC_Ul(k,args[0][1], args[1][1], args[2][1], args[3][1])[1]))
	elif phenomene == 'RLC_I':	
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.RLC_I(k,args[0][1], args[1][1], args[2][1], args[3][1])[1]))
	elif phenomene == 'GRL_Ul':
		phase.write("set xlabel \"Time (s)\"\n")
		for k in liste(0 ,time, 0.01):
			coord.write('%s %s \n '%(k,fonctions.GRL_Ul(k,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'PHaut_G':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		# technic coz log scale
		for k in liste(1,3,1):
			for i in liste(10**(k-1),10**k, 10**(-3+k)):
				coord.write('%s %s \n'%(i,fonctions.PHaut_G(i,args[0][1], args[1][1])[1]))
	elif phenomene == 'PHaut_Phase':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0,1,10,100,1000]
		serie_pas = [0.001,0.01,0.1,1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.PHaut_Phase(i,args[0][1], args[1][1])[1]))
	elif phenomene == 'PBas_G':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		for k in liste(1,3,1):
			for i in liste(10**(k-1),10**k, 10**(-3+k)):
				coord.write('%s %s \n'%(i,fonctions.PBas_G(i,args[0][1], args[1][1])[1]))
	elif phenomene == 'PBas_Phase':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0,1,10,100,1000]
		serie_pas = [0.001,0.01,0.1,1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.PBas_Phase(i,args[0][1], args[1][1])[1]))
	elif phenomene == 'PBande_G':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0.01,1,10,100,1000]
		serie_pas = [0.01,0.01,0.1,1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.PBande_G(i,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'PBande_Phase':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0.01,1,10,100,1000]
		serie_pas = [0.001,0.01,0.1,1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.PBande_Phase(i,args[0][1], args[1][1], args[2][1])[1]))
	elif phenomene == 'CBande_G':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0,1,10,100]
		serie_pas = [0.01,0.01,0.1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.CBande_G(i,args[0][1], args[1][1], args[2][1], args[3][1])[1]))
	elif phenomene == 'CBande_Phase':
		phase.write("set xlabel \"log(w) \"\n")
		phase.write("set logscale x\n")
		serie = [0.1,1,10,100]
		serie_pas = [0.001,0.01,0.1]
		for k in range(0,len(serie)-1,1):
			for i in liste(serie[k], serie[k+1], serie_pas[k]):
				coord.write('%s %s \n'%(i,fonctions.CBande_Phase(i,args[0][1], args[1][1], args[2][1], args[3][1])[1]))

	elif phenomene.startswith('Circuit_filter'):
		phase.write("set xlabel \"log(w) \"\n")
		# list_comp = ['Resistor','Interrupt Off',...]
		# list_composants = [None,'R','L','C']
		
		Z_ = None
		
		list_composants = []
		for elt in list_comp:
			if elt == 'Resistor': list_composants.append('R')
			elif elt == 'Inductor': list_composants.append('L')
			elif elt == 'Capacitor': list_composants.append('C')
			else: list_composants.append(None)
		
		type = []
		if list_comp[0] == 'Interrupt On':
			type.append(1)
	                Z_ = 1

	        if list_comp[0] != 'Interrup On' and (list_comp[1] == 'Interrupt On' or list_comp[2] == 'Interrupt On'):
	                type.append(2)
			Z_ = 1

	        if list_comp[1] == 'Interrupt Off':
	                type.append(3)

		if list_comp[2] == 'Interrupt Off':
		        type.append(4)

		if Z_ == None:
			type.append(5)
		
		phase.write("set logscale x\n")
		serie = [0.001, 0.01,0.1,1,10,100,1000]
		serie_pas = [0.001,0.01,0.01,0.01,0.1,1]
		for k in range(0,len(serie)-1,1):
		        for i in liste(serie[k], serie[k+1], serie_pas[k]):
					dicoco = {}
					for elt in args:
						if elt[0] == 'R':
				                        dicoco[elt[0]] = elt[1]
						elif elt[0] == 'L':
							dicoco[elt[0]] = complex(0,elt[1]*i)
						elif elt[0] == 'C':
							dicoco[elt[0]] = complex(0,-1/(elt[1]*i))
					if 3 in type: Z2 = 0
					if 4 in type: Z3 = 0
					if 2 in type: Z_ = dicoco[list_composants[0]]
					if 1 in type: Z_ = dicoco[list_composants[1]] + dicoco[list_composants[2]]
					if 5 in type: 
						Z1 = dicoco[list_composants[0]]
						Z2 = dicoco[list_composants[1]]
						Z3 = dicoco[list_composants[2]]

						Z_ = (Z1*(Z2+Z3))/(Z1+Z2+Z3)
					if phenomene == 'Circuit_filter_G':	
				                coord.write('%s %f \n'%(i,fonctions.gain_db(i,Z_,dicoco[list_composants[3]])[1]))
					elif phenomene == 'Circuit_filter_Phase':
						coord.write('%s %f \n'%(i,fonctions.phase(i,Z_,dicoco[list_composants[3]])[1]))
	
	phase.write("plot \'/tmp/%s-farfadet\' with %s"%(username, graph_style))
	phase.close()
	coord.close()



def gnu(username):
	os.system("gnuplot /tmp/%s-phase"%(username))
