#!/usr/bin/python

from os import *
import string, sys
import jedi, schema, help, erreur

try:
	import gtk
except:
	print 'ERROR : You must install pygtk !'
	sys.exit(0)


class session:
	
	def redraw(self):
		jedi.trace(self.list_args, self.phenomene, self.graph_style, self.comp_list)
		jedi.gnu(self.username)
		self.img_box.set_from_file("/tmp/%s-gnuplot-output.png"%(self.username))
	
	def set_graph_style(self, a, b):
		name = string.split(b.get_name(),'/')[-1]

		if name == 'Dots':
			self.graph_style = 'points pointtype 0 pointsize %f'%self.points_size
		elif name == 'Lines':
			self.graph_style = 'lines'
		elif name == 'Crosses':
			self.graph_style = 'points pointtype 2 pointsize %f'%self.points_size
		elif name == 'Stars':
			self.graph_style = 'points pointtype 3 pointsize %f'%self.points_size
		elif name == 'Squares':
			self.graph_style = 'points pointtype 4 pointsize %f' %self.points_size
		elif name == 'Triangles':
			self.graph_style = 'points pointtype 8 pointsize %f'%self.points_size
		elif name == 'Diamonds':
			self.graph_style = 'points pointtype 12 pointsize %f'%self.points_size
		
		try: self.redraw()
		except: pass
		
	
	def set_points_size(self, a,b):
		size = float(string.split(b.get_name(),'/')[-1])
		
		self.points_size = size/10.0
		if self.graph_style != 'lines':
			yop = string.split(self.graph_style)
			yop[-1] = str(self.points_size)
			self.graph_style = string.join(yop)

		try: self.redraw()
		except: pass
		
	def wanna_draw(self, a, b):
		try: self.clean()
		except: pass

		self.hbox_ = gtk.HBox(False, 3)
                self.hbox_.show()

		self.one_frame = gtk.Frame("Composants")
                self.one_frame.show()
                self.one_frame.add(self.hbox_)
                self.vert_box.pack_start(self.one_frame, 0, 0, 3)

		self.combobox1 = gtk.combo_box_new_text()
	        self.combobox1.append_text('Resistor')
	        self.combobox1.append_text('Capacitor')
	        self.combobox1.append_text('Inductor')
	        self.combobox1.append_text('Interrupt On')
	        self.combobox1.append_text('Interrupt Off')
	        self.combobox1.connect('changed', self.changed_first_comp)
	        self.combobox1.set_active(0)
		self.combobox1.show()

		self.combobox2 = gtk.combo_box_new_text()
		self.combobox2.append_text('Resistor')
		self.combobox2.append_text('Capacitor')
		self.combobox2.append_text('Inductor')
		self.combobox2.append_text('Interrupt On')
		self.combobox2.append_text('Interrupt Off')
		self.combobox2.connect('changed', self.changed_second_comp)
		self.combobox2.set_active(0)
		self.combobox2.show()

		self.combobox3 = gtk.combo_box_new_text()
		self.combobox3.append_text('Resistor')
		self.combobox3.append_text('Capacitor')
		self.combobox3.append_text('Inductor')
		self.combobox3.append_text('Interrupt On')
		self.combobox3.append_text('Interrupt Off')
		self.combobox3.connect('changed', self.changed_third_comp)
		self.combobox3.set_active(0)
		self.combobox3.show()

		self.combobox4 = gtk.combo_box_new_text()
		self.combobox4.append_text('Resistor')
		self.combobox4.append_text('Capacitor')
		self.combobox4.append_text('Inductor')
		self.combobox4.append_text('Interrupt On')
		self.combobox4.append_text('Interrupt Off')
		self.combobox4.connect('changed', self.changed_fourth_comp)
		self.combobox4.set_active(0)
		self.combobox4.show()
		
		self.hbox_.pack_start(self.combobox1, 0, 0, 3)
		self.hbox_.pack_start(self.combobox2, 0, 0, 3)
		self.hbox_.pack_start(self.combobox3, 0, 0, 3)
		self.hbox_.pack_start(self.combobox4, 0, 0, 3)

		# Run Button
		run_button = gtk.Button("Try this circuit !")
		run_button.connect("clicked", self.go)
		self.hbox_.pack_start(run_button, 0, 0, 3)
		run_button.show()

		
		# Circuit img frame		
		self.circ_frame = gtk.Frame("Circuit :")
                self.circ_box = gtk.Image()
                self.circ_box.set_from_file('pics/circ_empty.png')
                self.circ_frame.add(self.circ_box)
                self.circ_box.show()
                self.vert_box.pack_start(self.circ_frame)
                self.circ_frame.show()

	def get_active_text(self, combobox):
	        model = combobox.get_model()
	        active = combobox.get_active()
	        if active < 0:
	 		return None
	        return model[active][0]
	       
	def go(self, runbutton):

		error = 0
		
		comp1 = self.get_active_text(self.combobox1)
		comp2 = self.get_active_text(self.combobox2)
		comp3 = self.get_active_text(self.combobox3)
		comp4 = self.get_active_text(self.combobox4)
		#print 'Check !', comp1, comp2, comp3, comp4
		self.comp_list = [comp1, comp2, comp3, comp4]

		if self.comp_list[0] == 'Interrupt Off':
	                print 'Court-circuit zwiiiiggg !'
			erreur.essential("Court-circuit zwiiiig")
			error = 1
	                #sys.exit(0)

	        if self.comp_list[1] == 'Interrupt Off' and self.comp_list[2] == 'Interrupt Off':
	                print 'Court-circuit !!'
			erreur.essential("Court-circuit zwiiiig")
			error = 1
	                #sys.exit(0)

	        if self.comp_list[3] == 'Interrupt Off':
	                print 'Aucun interet !'
			erreur.essential("AUcun interet")
	                error = 1
			#sys.exit(0)


	        if self.comp_list[3] == 'Interrupt On':
	                print 'Aucun interet !'
			erreur.essential("AUcun interet")
			error = 1
	                #sys.exit(0)

		if error == 0:
			self.clean_2()
			lili = []
			if 'Resistor' in self.comp_list: lili.append('R')
			if 'Capacitor' in self.comp_list: lili.append('C')
			if 'Inductor' in self.comp_list: lili.append('L')
	
			self.create_dimension(['gain','phase'])
			self.create_data(lili)
			self.create_buttons()
	
			self.cur_circuit = 'Circuit_filter'

	def changed_first_comp(self, combobox):
	        #model = combobox.get_model()
                #index = combobox.get_active()
		#if index:
	        #	print 'I like', model[index][0], 'pie'
	        return
	
	def changed_second_comp(self, combobox):
		#model = combobox.get_model()
		#index = combobox.get_active()
		#if index:
		#	print 'I like', model[index][0], 'pie'
		return

	def changed_third_comp(self, combobox):
		#model = combobox.get_model()
		#index = combobox.get_active()
		#if index:
		#	print 'I like', model[index][0], 'pie'
		return

	def changed_fourth_comp(self, combobox):
		#model = combobox.get_model()
		#index = combobox.get_active()
		#if index:
		#	print 'I like', model[index][0], 'pie'
		return

		
	def clean(self):
		self.logobox.destroy()
		self.hbox.destroy()
		self.databox.destroy()
		self.buttons_box.destroy()
		self.data_frame.destroy()
		self.grandeur_frame.destroy()
		self.img_box.destroy()
		self.img_frame.destroy()

		jedi.initialisation()

	def clean_2(self):
		self.hbox_.destroy()
		self.one_frame.destroy()
		self.combobox1.destroy()
		self.combobox2.destroy()
		self.combobox3.destroy()
		self.combobox4.destroy()
		self.circ_frame.destroy()
		self.circ_box.destroy()
	
	def switch_circuit(self, a, b):
		name = string.split(b.get_name(),'/')[-1]
		if name == 'Passe-Bande': name = 'PBande'
		elif name == 'Passe-Bas': name = 'PBas'
		elif name == 'Passe-Haut': name = 'PHaut'
		elif name == 'Coupe-Bande': name = 'CBande'
		
		try:
			self.clean()
		except:
			pss = 'on'

		try:
			self.clean_2()
		except:
			pss = 'on'
			
		self.cur_circuit = name
		self.create_dimension(self.dico_dims[name])
		self.create_data(self.dico_params[name]) 
		self.create_buttons()
	
	
	def draw(self,schema_button):
		schema.principal(self.cur_circuit + '.jpg')

	def reset(self,reset_button):
		if path.exists('/tmp/%s-farfadet'%(self.username)):
			remove("/tmp/%s-farfadet"%(self.username));
		self.img_box.set_from_file("pics/default.png");
	
	def byebye(self,quit_button):
		if path.exists("/tmp/%s-farfadet"%(self.username)):
			remove("/tmp/%s-farfadet"%(self.username))
		if path.exists("/tmp/%s-phase"%(self.username)):
			remove("/tmp/%s-phase"%(selF.username))
		if path.exists("/tmp/%s-gnuplot-output.png"%(self.username)):
			remove("/tmp/%s-gnuplot-output.png"%(self.username))

		gtk.main_quit()

	def apropos(self,apropos_button, arg=None, arg_=None):
		help.essential()
	
	def run(self,runbutton):
		
		studied_dimension = ''
		for elt in self.dico_dim_buttons.keys():
			if elt.get_active() is True:
				studied_dimension = self.dico_dim_buttons[elt]
				
		self.list_args = []
		for elt in self.data_buttons:
			self.list_args.append([self.dico_labels[elt],elt.get_value()])
		
		self.phenomene = self.cur_circuit + '_' + studied_dimension
	
		# list_args = E, R, L, C, Time 
		jedi.trace(self.list_args, self.phenomene, self.graph_style, self.comp_list)
		jedi.gnu(self.username)
		self.img_box.set_from_file("/tmp/%s-gnuplot-output.png"%(self.username))
		
	def __init__(self):
	
		jedi.initialisation()

		self.username = environ.get("USER")
		self.dim_buttons = []
		self.data_buttons = []

		self.graph_style = 'points pointtype 0'
		self.points_size = 0.2

		self.comp_list = []

		self.dico_dims = {'RC':['intensity','c_tension','charge'],'RL':['intensity','l_tension'],'RLC':['intensity','c_tension','charge','l_tension'],'LC':['intensity','c_tension','l_tension','charge'],'GRC':['intensity','c_tension','charge'],'GRL':['intensity','l_tension'],'PBas':['gain','phase'],'PHaut':['gain','phase'],'PBande':['gain','phase'],'CBande':['gain','phase']}
		self.dico_params = {'RC':['E','R','C','Time'],'RL':['E','R','L','Time'],'RLC':['E','R','L','C','Time'],'LC':['E','L','C','Time'],'GRC':['E','R','C','Time'],'GRL':['E','R','L','Time'],'PBas':['R','C'],'PHaut':['R','C'],'PBande':['R','L','C'],'CBande':['R','L','C','r']}
		
		#main window
		self.main_win = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.main_win.connect("destroy", gtk.main_quit)
		self.main_win.set_title("Elektrik")
		self.main_win.set_default_size(400, 200)

		#main vertical box
		self.vert_box = gtk.VBox(False, 0);

		menu_items = (( "/_File",         None,        None, 0, "<Branch>" ),
			     ( "/File/Quit",     "<control>Q", gtk.main_quit, 0, None ),
			     ( "/_Circuit",      None,         None, 0, "<Branch>" ),
#			     ( "/Circuit/_Draw",  None,         None, 0, "<Branch>" ),
#			     ( "/Circuit/Draw/Filter",  None,   self.wanna_draw, 0, None ),
#			     ( "/Circuit/Draw/Other",  None,    self.wanna_draw, 0, None ),
			     ( "/Circuit/_GRLC",  None,        None, 0, "<Branch>" ),
			     ( "/Circuit/GRLC/RC", None,       self.switch_circuit, 0, None),
			     ( "/Circuit/GRLC/RL", None,       self.switch_circuit, 0, None),
			     ( "/Circuit/GRLC/LC", None,       self.switch_circuit, 0, None),
			     ( "/Circuit/GRLC/RLC", None,      self.switch_circuit, 0, None),
			     ( "/Circuit/GRLC/GRC", None,      self.switch_circuit, 0, None),
			     ( "/Circuit/GRLC/GRL", None,      self.switch_circuit, 0, None),
			     ( "/Circuit/_Filtres",  None,     None, 0, "<Branch>" ),
			     ( "/Circuit/Filtres/Passe-Haut",  None, 	self.switch_circuit, 0, None),
			     ( "/Circuit/Filtres/Passe-Bas",   None,     self.switch_circuit, 0, None),
			     ( "/Circuit/Filtres/Passe-Bande", None,   self.switch_circuit, 0, None),
			     ( "/Circuit/Filtres/Coupe-Bande", None,   self.switch_circuit, 0, None),
			     ( "/_Graph",      None,           None, 0, "<Branch>" ),
			     ( "/Graph/_Style",  None,         None, 0, "<Branch>" ),
			     ( "/Graph/Style/Dots", None,      self.set_graph_style, 0, None),
			     ( "/Graph/Style/Lines", None,     self.set_graph_style, 0, None),
			     ( "/Graph/Style/Crosses", None,   self.set_graph_style, 0, None),
			     ( "/Graph/Style/Stars", None,     self.set_graph_style, 0, None),
			     ( "/Graph/Style/Squares", None,   self.set_graph_style, 0, None),
			     ( "/Graph/Style/Triangles", None, self.set_graph_style, 0, None),
			     ( "/Graph/Style/Diamonds", None,  self.set_graph_style, 0, None),
			     ( "/Graph/_Size",  None,          None, 0, "<Branch>" ),
			     ( "/Graph/Size/1",  None,         self.set_points_size, 0, None ),
			     ( "/Graph/Size/2",  None,         self.set_points_size, 0, None ),
			     ( "/Graph/Size/5",  None,         self.set_points_size, 0, None ),
			     ( "/_Help",         None,         None, 0, "<LastBranch>" ),
			     ( "/Help/About",   None,          self.apropos, 0, None ),
			    )

		accel_group = gtk.AccelGroup()
		self.item_factory = gtk.ItemFactory(gtk.MenuBar, "<main>", accel_group)
		self.item_factory.create_items(menu_items)
		self.main_win.add_accel_group(accel_group)

		menubar = self.item_factory.get_widget("<main>")

		self.vert_box.pack_start(menubar, False, True, 0)
		
                self.logobox = gtk.Image()
                self.logobox.set_from_file('pics/logo.jpg')
                self.logobox.show()

                self.vert_box.pack_start(self.logobox)
		
		self.main_win.add(self.vert_box)

		menubar.show()
		self.vert_box.show()
		self.main_win.show()

		gtk.main()

	def create_dimension(self, liste):
		self.hbox = gtk.HBox(False, 0)
		self.hbox.show()
		self.grandeur_frame = gtk.Frame("Dimension");
		self.grandeur_frame.show();
		self.grandeur_frame.add(self.hbox);
		self.vert_box.pack_start(self.grandeur_frame, 1, 1, 3);
		
		self.dico_dim_buttons = {}
		
		if 'gain' in liste and 'phase' in liste:
			self.gain_button = gtk.RadioButton(None, "Gain (dB)")
			self.gain_button.show()
			self.hbox.pack_start(self.gain_button)
			
			self.phase_button = gtk.RadioButton(self.gain_button, "Phase (deg)")
			self.phase_button.show()
			self.hbox.pack_start(self.phase_button)

			self.gain_button.set_active(True)

			self.dico_dim_buttons[self.gain_button] = 'G'
			self.dico_dim_buttons[self.phase_button] = 'Phase'
		
		if 'intensity' in liste:
			self.intensity_button = gtk.RadioButton(None, "Intensity (I)")
			self.intensity_button.show()
			self.hbox.pack_start(self.intensity_button)

			self.intensity_button.set_active(True)
			
			self.dico_dim_buttons[self.intensity_button] = 'I'
	
		if 'c_tension' in liste:
			self.tensionC_button = gtk.RadioButton(self.intensity_button, "Tension C (Uc)")
			self.tensionC_button.show()
			self.hbox.pack_start(self.tensionC_button)

			self.dico_dim_buttons[self.tensionC_button] = 'Uc'
			
		if 'l_tension' in liste:
			self.tensionL_button = gtk.RadioButton(self.intensity_button, "Tension L (Ul)")
			self.tensionL_button.show()
			self.hbox.pack_start(self.tensionL_button)

			self.dico_dim_buttons[self.tensionL_button] = 'Ul'
		
		if 'charge' in liste:
			self.charge_button = gtk.RadioButton(self.intensity_button, "Charge (Q)")
			self.charge_button.show()
			self.hbox.pack_start(self.charge_button)

			self.dico_dim_buttons[self.charge_button] = 'Q'
		
		#self.vert_box.pack_start(self.hbox)
		
	def create_data(self, liste_params):
		self.databox = gtk.HBox(False, 0)
		self.databox.show()
		self.data_frame = gtk.Frame("Dimension")
		self.data_frame.show()
		self.data_frame.add(self.databox)
		self.vert_box.pack_start(self.data_frame, 1, 1, 3)
		
		self.data_buttons = []
		self.dico_labels = {}
		
		if 'E' in liste_params:
			e_adjustment = gtk.Adjustment(6, -999999999, 99999999, 0.1, 0, 0)

			label = gtk.Label("E : ")
			self.databox.pack_start(label)
			label.show()
			e_data = gtk.SpinButton(e_adjustment, 0.5, 5)
			e_data.show()
			self.databox.pack_start(e_data)

			self.data_buttons.append(e_data)
			self.dico_labels[e_data] = 'E'

		if 'R' in liste_params:
			R_adjustment = gtk.Adjustment(2, -999999999, 99999999, 0.1, 0, 0)

			label = gtk.Label("R : ")
			self.databox.pack_start(label)
			label.show()
			R_data = gtk.SpinButton(R_adjustment, 0.5, 5)
			R_data.show()
			self.databox.pack_start(R_data)

			self.data_buttons.append(R_data)
			self.dico_labels[R_data] = 'R'

		if 'L' in liste_params:
			l_adjustment = gtk.Adjustment(1.5, -999999999, 99999999, 0.1, 0, 0)

			label = gtk.Label("L : ")
			self.databox.pack_start(label)
			label.show()
			l_data = gtk.SpinButton(l_adjustment, 0.5, 5)
			l_data.show()
			self.databox.pack_start(l_data)

			self.data_buttons.append(l_data)
			self.dico_labels[l_data] = 'L'

		if 'r' in liste_params:
			r_adjustment = gtk.Adjustment(2, -999999999, 99999999, 0.1, 0, 0)

			label = gtk.Label("r : ")
			self.databox.pack_start(label)
			label.show()
			r_data = gtk.SpinButton(r_adjustment, 0.5, 5)
			r_data.show()
			self.databox.pack_start(r_data)

			self.data_buttons.append(r_data)
			self.dico_labels[r_data] = 'r'
		

		if 'C' in liste_params:
			c_adjustment = gtk.Adjustment(0.1, -999999999, 99999999, 0.1, 0, 0)

			label = gtk.Label("C : ")
			self.databox.pack_start(label)
			label.show()
			c_data = gtk.SpinButton(c_adjustment, 0.5, 5)
			c_data.show()
			self.databox.pack_start(c_data)

			self.data_buttons.append(c_data)
			self.dico_labels[c_data] = 'C'

		if 'Time' in liste_params:
			time_adjustment = gtk.Adjustment(10, -999999999, 99999999, 1, 0, 0)

			label = gtk.Label("Time: ")
			self.databox.pack_start(label)
			label.show()
			time_data = gtk.SpinButton(time_adjustment, 0.5, 5)
			time_data.show()
			self.databox.pack_start(time_data)

			self.data_buttons.append(time_data)
			self.dico_labels[time_data] = 'time'

	def create_buttons(self):
		self.buttons_box = gtk.HBox(False, 0)
		self.buttons_box.show()
		
		#apropos_button = gtk.Button("About...")
		#apropos_button.connect("clicked", self.apropos)
		#self.buttons_box.pack_start(apropos_button)
		#apropos_button.show()

		#quit_button = gtk.Button("Quit")
		#quit_button.connect("clicked", self.byebye)
		#self.buttons_box.pack_start(quit_button)
		#quit_button.show()

		reset_button = gtk.Button("Reset")
		reset_button.connect("clicked", self.reset)
		self.buttons_box.pack_start(reset_button)
		reset_button.show()

		schema_button = gtk.Button("Diagram")
		schema_button.connect("clicked", self.draw)
		self.buttons_box.pack_start(schema_button)
		schema_button.show()

		run_button = gtk.Button("Run")
		run_button.connect("clicked", self.run)
		self.buttons_box.pack_start(run_button)
		run_button.show()

		self.vert_box.pack_start(self.buttons_box)
		
		self.img_frame = gtk.Frame("Graphic :")
		self.img_box = gtk.Image()
		self.img_box.set_from_file('pics/default.png')
		self.img_frame.add(self.img_box)
		self.img_box.show()
		
		self.vert_box.pack_start(self.img_frame)
		self.img_frame.show()

if system('which gnuplot') == 256:
	print 'ERROR : You must install Gnuplot in order to use Elektrik !'
	erreur.essential("You must install Gnuplot in order to use Elektrik !\nSee http://www.gnuplot.info for download.")
else:
	p = session()
